<template>
  <h1>Colors</h1>

  <rui-actions>
    <small class="-text--helping">Values are extracted from current theme.</small>
    <rui-button icon="reload" caption="Refresh" @click="setScssVariables" />
  </rui-actions>

  <div v-for="(group, index) in colors" :key="index">
    <h2>{{ group.title }}</h2>

    <div class="-grid-4 -grid--gap">
      <div v-for="c in group.colors" :key="c" class="_card">
        <div class="_card__content">
          <div class="-flex -flex--gap">
            <code>{{ c }}</code>
            <div class="-flex--grow -text--right">
              <code :data-css-var="c" />
            </div>
          </div>
        </div>
        <div class="-pd" :style="`background: var(${c})`">&nbsp;</div>
        <div :style="`color: var(${c})`" class="_card__content">{{ sampleText }}</div>
      </div>
    </div>
  </div>
</template>

<script>
import { setScssVariables, sampleText } from './utils.js'

const colors = [
  {
    title: 'Base colors',
    colors: [
      '--background-color',
      '--background-color-alt',
      '--foreground-color',
    ],
  },
  {
    title: 'Borders',
    colors: [
      '--border-color',
      '--border-color-alt',
    ],
  },
  {
    title: 'Text selection',
    colors: [
      '--selection-background-color',
      '--selection-foreground-color',
    ],
  },
  {
    title: 'Overlays',
    colors: [
      '--overlay-color',
    ],
  },
  {
    title: 'Generic components',
    colors: [
      '--component-content-background',
      '--component-content-background-alt',
    ],
  },
  {
    title: 'Buttons',
    colors: [
      '--button-color',
      '--button-background',
      '--button-background--hover',
      '--button-background--active',
      '--button-color--disabled',
      '--button-background--disabled',
    ],
  },
  {
    title: 'Badges',
    colors: [
      '--badge-background',
      '--badge-color',
    ],
  },
  {
    title: 'Links',
    colors: [
      '--link-color',
      '--link-color--hover',
    ],
  },
  {
    title: 'Loading state',
    colors: [
      '--loading-color',
    ],
  },
  {
    title: 'Tables',
    colors: [
      '--table-background--hover',
    ],
  },
  {
    title: 'States: blue',
    colors: [
      '--state-color-blue',
      '--state-color-blue--hover',
      '--state-color-blue--active',
      '--state-color-blue-alt',
    ],
  },
  {
    title: 'States: green',
    colors: [
      '--state-color-green',
      '--state-color-green--hover',
      '--state-color-green--active',
      '--state-color-green-alt',
    ],
  },
  {
    title: 'States: red',
    colors: [
      '--state-color-red',
      '--state-color-red--hover',
      '--state-color-red--active',
      '--state-color-red-alt',
    ],
  },
  {
    title: 'States: orange',
    colors: [
      '--state-color-orange',
      '--state-color-orange--hover',
      '--state-color-orange--active',
      '--state-color-orange-alt',
    ],
  },
  {
    title: 'States: mute',
    colors: [
      '--state-color-mute',
      '--state-color-mute-alt',
    ],
  },
]

export default {
  name: 'ColorsView',

  data () {
    return {
      sampleText,
      colors,
    }
  },
  methods: {
    setScssVariables,
  },
  created () {
    this.$setTitle('Colors')

    this.$nextTick(() => {
      this.setScssVariables()
    })
  },
}
</script>
